<%@ Page Language="C#" AutoEventWireup="true" CodeFile="DefaultCS.aspx.cs" Inherits="RadUploadInAjaxifiedGrid_DefaultCS" %>

<%@ register assembly="RadUpload.NET2" namespace="Telerik.WebControls" tagprefix="radu" %>
<%@ register assembly="RadAjax.NET2" namespace="Telerik.WebControls" tagprefix="rada" %>
<%@ register assembly="RadGrid.NET2" namespace="Telerik.WebControls" tagprefix="radg" %>
<%@ register assembly="RadComboBox.NET2" namespace="Telerik.WebControls" tagprefix="radcb" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <form id="form1" runat="server">
    <script type="text/javascript">
            //on insert and update buttons click temporarily disables ajax to perform upload actions
            function conditionalPostback(e, sender)
            {
                var theRegexp = new RegExp("\.UpdateButton$|\.PerformInsertButton$", "ig");
			    if (sender.EventTarget.match(theRegexp))
			    {
			        var upload = window['UploadId'];
			        
			        //AJAX is disabled only if file is selected for upload
			        if(upload.GetFileInputs()[0].value != "")
			        {
			            sender.EnableAjax = false;
			        }
			    }
            }
            
            function SelectName(name, value)
            {    
               if(window['AuthorListId'] != null)
               {
                   var authorsListClientId = window['AuthorListId'];
                   authorsListClientId.SetText(name);
                   authorsListClientId.SetValue(value);
               }
            }
        </script>

        <radu:radprogressmanager id="RadProgressManager1" runat="server" />
        <radg:radgrid runat="server" id="RadGrid1" enableajax="true" pagesize="10" allowpaging="true"
            allowsorting="true" autogeneratecolumns="false" allowmultirowedit="false" width="97%"
            datasourceid="SqlDataSource1" onupdatecommand="RadGrid1_UpdateCommand" oninsertcommand="RadGrid1_InsertCommand"
            ondeletecommand="RadGrid1_DeleteCommand" skin="Web20" onitemdatabound="RadGrid1_ItemDataBound" ShowStatusBar="true">
            <clientsettings>
                <clientevents onrequeststart="conditionalPostback" />
            </clientsettings>
            <pagerstyle mode="NextPrevAndNumeric" />
            <mastertableview width="100%" editmode="EditForms" commanditemdisplay="Top" datakeynames="ID">
                <columns>
                    <radg:grideditcommandcolumn>
                    </radg:grideditcommandcolumn>
                    <radg:gridtemplatecolumn headertext="Image Name" uniquename="ImageName" sortexpression="Name">
                        <itemtemplate>
                            <asp:label runat="server" id="lblName" text='<%# Eval("Name") %>' />
                        </itemtemplate>
                        <edititemtemplate>
                            <asp:textbox runat="server" style="width: 205px; margin-left: 3px;" id="txbName"
                                text='<%# Bind("Name") %>' />
                            <asp:requiredfieldvalidator id="Requiredfieldvalidator1" runat="server" controltovalidate="txbName"
                                errormessage="Please, enter a name!" display="Dynamic" setfocusonerror="true">
                            </asp:requiredfieldvalidator>
                        </edititemtemplate>
                    </radg:gridtemplatecolumn>
                    <radg:gridtemplatecolumn headertext="Description" uniquename="Description" datafield="Description">
                        <itemtemplate>
                            <asp:label id="lblDescription" runat="server" text='<%# Eval("Description") %>' />
                        </itemtemplate>
                        <edititemtemplate>
                            <asp:textbox id="txbDescription" style="width: 205px; margin-left: 4px;" runat="server"
                                textmode="MultiLine" text='<%# Bind("Description") %>' />
                        </edititemtemplate>
                    </radg:gridtemplatecolumn>
                    <radg:gridtemplatecolumn headertext="Author" uniquename="Author">
                        <itemtemplate>
                            <asp:label id="lblAuthorName" runat="server" text='<%# Eval("AuthorName") %>'>
                            </asp:label>
                        </itemtemplate>
                        <edititemtemplate>
                            <radcb:radcombobox id="AuthorImagesList" runat="server" skin="Default" 
                                style="margin-left: 4px;"  
                                width="205" >
                                <itemtemplate>
                                    <asp:datagrid id="AuthorsGrid" runat="server" autogeneratecolumns="False" datasourceid="SqlDataSource2"
                                        gridlines="Horizontal" style="border: 0px;" width="90%" showheader="false">
                                        <itemstyle font-size="8pt" />
                                        <headerstyle backcolor="#DADAD9" font-bold="True" font-size="8pt" height="30" />
                                        <columns>
                                            <asp:templatecolumn>
                                                <itemtemplate>
                                                    <asp:image id="AuthorImage" runat="server" imageurl='<%# "AuthorsImages/" + Eval("AuthorImageName") %>' />
                                                </itemtemplate>
                                            </asp:templatecolumn>
                                            <asp:templatecolumn>
                                                <itemtemplate>
                                                    <a href='javascript:SelectName("<%# Eval("AuthorName") %>", "<%# Eval("ID") %>")'>
                                                        <%# Eval("AuthorName") %>
                                                    </a>
                                                </itemtemplate>
                                            </asp:templatecolumn>
                                        </columns>
                                    </asp:datagrid>
                                </itemtemplate>
                                <items>
                                    <radcb:radcomboboxitem id="RadComboBoxItem1" runat="Server" selected="True"  />
                                </items>
                            </radcb:radcombobox>
                            <asp:requiredfieldvalidator id="Requiredfieldvalidator2" runat="server" controltovalidate="AuthorImagesList"
                                display="Dynamic" errormessage="Please, select an author!" setfocusonerror="true" initialvalue="">
                            </asp:requiredfieldvalidator>
                            <asp:hiddenfield id="initialAuthorName" runat="server" value='<%# Eval("AuthorName") %>' />
                            <asp:hiddenfield id="initialAuthorValue" runat="server" value='<%# Eval("AuthorNameID") %>' />
                        </edititemtemplate>
                    </radg:gridtemplatecolumn>
                    <radg:gridtemplatecolumn headertext="Image" uniquename="Upload">
                        <itemtemplate>
                            <a target="_blank" href="ShowImageCS.aspx?id=<%# Eval("ID") %>">
                                <asp:image runat="server" id="ImageThumbnail" alternatetext="Click here to open the real size image"
                                    imageurl='<%# "Thumbnails/" + Eval("ID") + Eval("Extension") %>'
                                    style="border-width: 0px;" />
                            </a>
                        </itemtemplate>
                        <edititemtemplate>
                            <radu:radupload id="RadUpload1" runat="server" skin="Desert" initialfileinputscount="1"
                                maxfileinputscount="1" controlobjectsvisibility="None" maxfilesize="1000000"
                                allowedfileextensions=".jpg,.bmp,.gif,.dib,.jpeg,.jpe,.jfif,.png,.tif,.tiff" />
                        </edititemtemplate>
                    </radg:gridtemplatecolumn>
                    <radg:gridbuttoncolumn headertext="Delete" text="Delete" commandname="Delete" uniquename="column">
                    </radg:gridbuttoncolumn>
                </columns>
                <editformsettings>
                    <editcolumn uniquename="EditCommandColumn1">
                    </editcolumn>
                </editformsettings>
                <expandcollapsecolumn visible="False">
                    <headerstyle width="19px" />
                </expandcollapsecolumn>
                <rowindicatorcolumn visible="False">
                    <headerstyle width="20px" />
                </rowindicatorcolumn>
            </mastertableview>
        </radg:radgrid>
        
        <asp:sqldatasource id="SqlDataSource1" runat="server" connectionstring="<%$ ConnectionStrings:demoConnectionString1 %>"
            providername="<%$ ConnectionStrings:demoConnectionString1.ProviderName %>" selectcommand="SELECT * 
            FROM [Images] INNER JOIN [Authors] ON [Images].[AuthorNameID] = [Authors].[ID]">
        </asp:sqldatasource>
        <asp:sqldatasource id="SqlDataSource2" runat="server" connectionstring="<%$ ConnectionStrings:demoConnectionString1 %>"
            providername="<%$ ConnectionStrings:demoConnectionString1.ProviderName %>" selectcommand="SELECT * FROM [Authors]">
        </asp:sqldatasource>
    </form>
</body>
</html>
